﻿/**************************************************************************
@ file name PositionPanel.jsx
@ description 基準点からの選択範囲の座標とサイズ、HTML用のスタイルシートを表示
@ version 1.0
@ author Tsudoi Yoshimoto
@ url http://tsudoi.org/weblog/?p=1264
@ last update date 2013.04.19
**************************************************************************/

function guideToReferencePoint(){
	var _xml = "<object>"; 
	try{
		var _bounds = app.activeDocument.selection.bounds;
		var _x0 = parseInt(_bounds[0]);
		var _y0 = parseInt(_bounds[1]);
		_xml += convertToXML(_y0, "pTop");
		_xml += convertToXML(_x0, "pLeft");
	}
	catch(e){
		_xml += convertToXML("NaN", "pTop");
		_xml += convertToXML("NaN", "pLeft");
	}
	_xml += "</object>";
	return _xml;
}


function guideToSelectionRange(){
	var _xml = "<object>"; 
	try{
		var _bounds = app.activeDocument.selection.bounds;
		var _x0 = parseInt(_bounds[0]);
		var _y0 = parseInt(_bounds[1]);
		var _x1 = parseInt(_bounds[2]);
		var _y1 = parseInt(_bounds[3]);
		_xml += convertToXML(_y0, "top");
		_xml += convertToXML(_x0, "left");
		_xml += convertToXML((_x1-_x0), "width");
		_xml += convertToXML((_y1-_y0), "height");
	}
	catch(e){
		_xml += convertToXML("NaN", "top");
		_xml += convertToXML("NaN", "left");
		_xml += convertToXML("NaN", "width");
		_xml += convertToXML("NaN", "height");
	}
	_xml += "</object>";
	return _xml;
}

function convertToXML(property, identifier){
	var type = typeof property;
	var xml = '<property id = "' + identifier + '" >';
	
	switch(type){
		case "number":
			xml += "<number>";
			xml += property.toString();
			xml += "</number>";
			break;
		case "boolean":
			xml += "<" + property.toString() + "/>";
			break;
		case "string":
			xml += "<string>";
			xml += property.toString();
			xml += "</string>";
			break;
		case "object":
			alertDebug("Object case is currently not supported");
			break;
		case "undefined":
			xml += "<string>undefined</string>";
			break;
		default:
			alertDebug("Type " + type + " is unknown.");
			return "";
	}
	xml += '</property>';
	return xml;
}